const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const purchase_requisition_lines = sequelize.define(
    'purchase_requisition_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

description: {
        type: DataTypes.TEXT,
      
      

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_price_estimate: {
        type: DataTypes.DECIMAL,
      
      

      },

line_total_estimate: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  purchase_requisition_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.purchase_requisition_lines.belongsTo(db.purchase_requisitions, {
      as: 'purchase_requisition',
      foreignKey: {
        name: 'purchase_requisitionId',
      },
      constraints: false,
    });

    db.purchase_requisition_lines.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.purchase_requisition_lines.belongsTo(db.warehouses, {
      as: 'warehouse',
      foreignKey: {
        name: 'warehouseId',
      },
      constraints: false,
    });

    db.purchase_requisition_lines.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.purchase_requisition_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.purchase_requisition_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return purchase_requisition_lines;
};


